using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_EntityFramework;
using Exferia_Expedientes._0_Modelos;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Exferia_Expedientes._3_Vistas.Listados
{
    public class ABS_Listado_EPD_Procedimientos_P_Demandado : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_EPD_Procedimientos_P_Demandado()
        {
            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            //id
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.id), "id", Enumerados.G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, true, false, "", null));

            //numero
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.numero), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.numero), "Número", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 90, true, true, true, false, "", null));

            //Materia
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_MATERIA = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.idMateria), nameof(EPD_Materias), nameof(EPD_Materias.id), nameof(EPD_Materias.codigo), nameof(EPD_Materias.descripcion), nameof(EPD_Materias.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.Materia), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.Materia), "Materia", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true,true,true, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_MATERIA));

            //numeroEjecucion
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.numeroEjecucion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.numeroEjecucion), "Número ejecución", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 110, true, false, true, false, "", null));

            //Expediente
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_EXPEDIENTE = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.idExpediente), nameof(EPD_Expedientes), nameof(EPD_Expedientes.id), nameof(EPD_Expedientes.codigo), nameof(EPD_Expedientes.descripcion), nameof(EPD_Expedientes.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.Expediente), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.Expediente), "Expediente", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_EXPEDIENTE));

            //Empresa
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_EMPRESA = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.idEmpresa), nameof(GEN_Empresas), nameof(GEN_Empresas.id), nameof(GEN_Empresas.codigo), nameof(GEN_Empresas.descripcion), nameof(GEN_Empresas.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.Empresa), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.Empresa), "Empresa", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_EMPRESA));

            //Juzgado
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_JUZGADO = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.idJuzgado), nameof(EPD_Juzgados), nameof(EPD_Juzgados.id), nameof(EPD_Juzgados.codigo), nameof(EPD_Juzgados.descripcion), nameof(EPD_Juzgados.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.Juzgado), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.Juzgado), "Juzgado", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_JUZGADO));

            //Actores
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.Actores), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.Actores), "Actores", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 150, true, false, true, false, "", null, false));

            //observaciones
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.observaciones), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.observaciones), "Observaciones", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 150, true, false, true, false, "", null));
        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }


        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_EPD_PROCEDIMIENTOS);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_EPD_PROCEDIMIENTOS + "_P_Demandado";
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_EPD_Procedimientos_Listado_Modelo.numero);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
